(	
global MFL_Rollout
	try (destroydialog MFL_Rollout)catch()
	
	local getLayer = undefined
	local objList  = undefined
	local re = undefined
	local newMask = undefined
	local LayerIndex = undefined
	local LayerIndexN = undefined
	
	rollout MFL_Rollout "Masks from Render Layers"
(
	button 'btn1' "Create" pos:[10,170] width: 240 height: 40 align:#center tooltip: "This script will create a MultiMatteElement for all objects in the selected Render Layers. Note: It will set G-Buffer IDs for the objects in the respective layer."
	multilistbox 'lst1' "Layers" pos:[10,10] width: 240 items: (for i=0 to layermanager.count-1 collect (layermanager.getLayer i).name)
	
	label 'edt4' " Chaos 3D Support Team" pos:[120,220]
	hyperlink 'link1' "V-Ray Knowledge Base" pos:[140,235] color: (color 39 200 255) hovercolor: (color 39 140 255) address:"https://support.chaos.com/hc/en-us/sections/10633063984273-V-Ray-Knowledge-Base-"
	
	fn isVRayCurrent = matchPattern (renderers.current as string) pattern:"*V_RAY*"
	fn delete_empty_layers = (
	local counter = 0
 
	for id = LayerManager.count - 1 to 1 by -1 do
	(
		local layer = LayerManager.getLayer id
 
		local contains_nodes = LayerManager.doesLayerHierarchyContainNodes layer.name
 
		if not contains_nodes then
		(
			local deleted = LayerManager.deleteLayerByName layer.name
 
			if deleted then counter += 1
		)
	)
 
	return counter
	)
	
	fn layerToMask = (
		for i=1 to (lst1.selection as array).count do
		(
		LayerIndex = (lst1.selection as array)[i]
		LayerIndexN = LayerIndex - 1

		clearSelection()
		getLayer = layerManager.getLayer LayerIndexN
		getLayer.select true
		
		objList = getCurrentSelection()
		for p=1 to objList.count do 
		(
		select objList[p]
		$.gbufferchannel = LayerIndex
		)	
		
		re=maxOps.GetCurRenderElementMgr()
		newMask = MultiMatteElement()
		newMask.ElementName = getLayer.name
		newmask.R_gbufID = LayerIndex
		newmask.G_gbufID = LayerIndex
		newmask.B_gbufID = LayerIndex
		re.AddRenderElement(newMask) 
	)
)
	
		
	on btn1 pressed do 
	(
		if isVRayCurrent() == true then print "Okay." else return messageBox "V-Ray is not set to current renderer!" title: "Error!"
		--delete_empty_layers()
		layerToMask()
	)
)
	createDialog MFL_Rollout 260 260
)